void main() {
    float normalizedPosition = (v_path_distance / u_path_length);
    
    // Prepare start / stop colors...
    vec4 fg_col = mix(glowStartColor, glowStopColor, normalizedPosition);
    fg_col.a *= mix(glowStartIntensity, glowStopIntensity, normalizedPosition);
    
    // Evaluate factor w, to add shading to start and end cap...
    float in_start = step(normalizedPosition, 0.0);
    float in_end = step(0.999999, normalizedPosition);
    
    float w = in_start * mod(v_tex_coord.x * 2.0, 1.0) +
              in_end * (1.0 - (mod((v_tex_coord.x - u_path_length / glowWidth) * 2.0, 1.0))) +
              (1.0 - in_start - in_end);
    
    // Apply alpha for glow effect...
    fg_col.a *= smoothstep(-1.0, 0.0, -distance(vec2(w, v_tex_coord.y*2.0), vec2(1.0, 1.0))); // *= sin(v_tex_coord.y*3.141592653) * pow(w, 1.5);
    
    // Premultiply alpha...
    fg_col.xyz *= fg_col.a;
    gl_FragColor = fg_col;
}

